package com.ruoyi.receive.kafka.config;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.kafka.core.KafkaOperations;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Component;
import javax.annotation.PostConstruct;

@Component
@Slf4j
public class KafkaSender {
    public final static String MSG_TOPIC = "first";

    @Autowired
    private KafkaTemplate<Object,Object> kafkaTemplate;
    private static KafkaTemplate template;

    @PostConstruct
    public void init() {
        KafkaSender.template = this.kafkaTemplate;
    }

    //发送消息到kafka队列
    public static boolean send(String topic,Integer partition, String key,String message) {
        try {
            //在发送消息的方法中使用KafkaTemplate.executeInTransaction()方法，将发送消息的操作放在事务范围内。
            template.executeInTransaction(new KafkaOperations.OperationsCallback<String, String, Object>() {
                @Override
                public Object doInOperations(KafkaOperations<String, String> kafkaOperations) {
                    kafkaOperations.send(topic, partition,key,message);
                    log.info("消息发送成功：{} , {}", topic, message);
                    return null;
                }
            });
        } catch (Exception e) {
            log.error("消息发送失败：{} , {}", topic, message, e);
            return false;
        }
        return true;
    }

}
