package com.ruoyi.receive.kafka.consumer;

import com.ruoyi.receive.domain.VehicleConstant;

public class KafkaConsumer {


    public static boolean checkMessageHandler(String message){

        if(!message.contains(VehicleConstant.DATA_PACK_SEPARATOR)){
            return false;
        }
        String temp = message.replaceAll("#\\$&\\*","");
        if(message.indexOf(VehicleConstant.MSG_START) !=0) return false;
        if((message.lastIndexOf(VehicleConstant.MSG_END)+2) != temp.length()) return false;
        String content = message.substring(2,message.length()-9);
        String data = content.replace(" ", "");
        int dSum = 0;
        int length = data.length();
        int index = 0;
        // 遍历十六进制，并计算总和
        while (index < length) {
            // 截取2位字符
            String s = data.substring(index, index + 2);
            // 十六进制转成十进制 , 并计算十进制的总和
            dSum += Integer.parseInt(s, 16);
            index = index + 2;
        }
        // 用256取余，十六进制最大是FF，FF的十进制是255
        int mod = dSum % 256;
        // 余数转成十六进制
        String checkSumHex = Integer.toHexString(mod);
        length = checkSumHex.length();
        if (length < 2) {
            // 校验位不足两位的，在前面补0
            checkSumHex = "0" + checkSumHex;
        }
        String parityBit = message.substring(message.length() - 9,message.length() - 7);
        return parityBit.equals(checkSumHex);
    }

}
