package com.ruoyi.receive.service;

import com.ruoyi.common.core.utils.SpringUtils;
import com.ruoyi.common.redis.service.RedisService;
import com.ruoyi.receive.domain.VehicleMessage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PostMapping;

import javax.annotation.PostConstruct;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 消息处理上下文
 */
@Component
public class MessageContext {

    @Autowired
    private RedisService redisService;

    private Map<String,MessageService> messageServiceMap = new HashMap<>();



    @PostConstruct
    private void init(){
        List<String> allMessageServiceKeyList = redisService.getCacheObject("消息处理的key");
        allMessageServiceKeyList.forEach(allMessageServiceKey ->{
            MessageService messageService = SpringUtils.getBean(allMessageServiceKey);
            messageServiceMap.put(allMessageServiceKey,messageService);
        });
    }

    public void handler(VehicleMessage message){
        String vinCode = message.getVinCode();

        List<String> analysisList = redisService.getCacheList("msg:analysis:" + vinCode);

        analysisList.forEach(analysis ->{
           MessageService messageService = messageServiceMap.get(analysis);
           messageService.excetion(message);
        });



    }

}

